#ifndef _KGR_PATCH_BSC1039496_H
#define _KGR_PATCH_BSC1039496_H

#if defined(CONFIG_X86_64)

int kgr_patch_bsc1039496_init(void);

int kgr_copy_strings_kernel(int argc, const char *const *__argv,
	struct linux_binprm *bprm);
asmlinkage long kgr_sys_execve(const char __user * filename,
	const char __user *const __user *argv,
	const char __user *const __user *envp);
int kgr_do_execve(const char *filename,
	const char __user *const __user *__argv,
	const char __user *const __user *__envp);
asmlinkage long kgr_compat_sys_execve(const char __user * filename,
	const compat_uptr_t __user * argv,
	const compat_uptr_t __user * envp);
int kgr_remove_arg_zero(struct linux_binprm *bprm);
void kgr_show_map_vma(struct seq_file *m, struct vm_area_struct *vma, int is_pid);
long kgr__get_user_pages(struct task_struct *tsk, struct mm_struct *mm,
	unsigned long start, unsigned long nr_pages, unsigned int gup_flags,
	struct page **pages, struct vm_area_struct **vmas, int *nonblocking);
int kgr_handle_mm_fault(struct mm_struct *mm, struct vm_area_struct *vma,
	unsigned long address, unsigned int flags);
int kgr_expand_downwards(struct vm_area_struct *vma, unsigned long address);
int kgr_expand_stack(struct vm_area_struct *vma, unsigned long address);
struct mm_struct *kgr_mm_init(struct mm_struct *mm, struct task_struct *p);

#if !defined(CONFIG_XEN)
int kgr_do_huge_pmd_anonymous_page(struct mm_struct *mm,
	struct vm_area_struct *vma, unsigned long address, pmd_t *pmd,
	unsigned int flags);
unsigned int kgr_khugepaged_scan_mm_slot(unsigned int pages, struct page **hpage);

#define KGR_PATCH_BSC1039496_FUNCS \
	KGR_PATCH(copy_strings_kernel, kgr_copy_strings_kernel), \
	KGR_PATCH(SyS_execve, kgr_sys_execve), \
	KGR_PATCH(do_execve, kgr_do_execve), \
	KGR_PATCH(compat_sys_execve, kgr_compat_sys_execve), \
	KGR_PATCH(remove_arg_zero, kgr_remove_arg_zero), \
	KGR_PATCH(show_map_vma, kgr_show_map_vma), \
	KGR_PATCH(do_huge_pmd_anonymous_page, kgr_do_huge_pmd_anonymous_page), \
	KGR_PATCH(khugepaged_scan_mm_slot, kgr_khugepaged_scan_mm_slot), \
	KGR_PATCH(__get_user_pages, kgr__get_user_pages), \
	KGR_PATCH(handle_mm_fault, kgr_handle_mm_fault), \
	KGR_PATCH(expand_downwards, kgr_expand_downwards), \
	KGR_PATCH(expand_stack, kgr_expand_stack), \
	KGR_PATCH(mm_init, kgr_mm_init),

#else /* !CONFIG_XEN */
#define KGR_PATCH_BSC1039496_FUNCS \
	KGR_PATCH(copy_strings_kernel, kgr_copy_strings_kernel), \
	KGR_PATCH(SyS_execve, kgr_sys_execve), \
	KGR_PATCH(do_execve, kgr_do_execve), \
	KGR_PATCH(compat_sys_execve, kgr_compat_sys_execve), \
	KGR_PATCH(remove_arg_zero, kgr_remove_arg_zero), \
	KGR_PATCH(show_map_vma, kgr_show_map_vma), \
	KGR_PATCH(__get_user_pages, kgr__get_user_pages), \
	KGR_PATCH(handle_mm_fault, kgr_handle_mm_fault), \
	KGR_PATCH(expand_downwards, kgr_expand_downwards), \
	KGR_PATCH(expand_stack, kgr_expand_stack), \
	KGR_PATCH(mm_init, kgr_mm_init),

#endif /* !CONFIG_XEN */

#else /* CONFIG_X86_64 */

static inline int kgr_patch_bsc1039496_init(void) { return 0; }

#define KGR_PATCH_BSC1039496_FUNCS

#endif /* CONFIG_X86_64 */

static inline void kgr_patch_bsc1039496_cleanup(void) {}

#endif
